<template>
  <basic-container>
    <el-dialog :visible.sync="commentVisible" width="80%" :modal-append-to-body="false" append-to-body center>
      <comment ref="comment" :relationId="meetingId" relationType="2"></comment>
    </el-dialog>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.meetinglist_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="menu" slot-scope="{row}">
        <el-button type="text" size="mini" icon="el-icon-s-comment" @click="showComment(row)">评论</el-button>
      </template>
      <template slot="content" slot-scope="{row}">
        <el-button size="mini" @click="showContent(row)">查看会议内容</el-button>
      </template>
      <template slot="meetingStatus" slot-scope="{row}">
        <el-switch v-model="row.meetingStatus"
                   :active-value=1 active-text="开启"
                   :inactive-value=0 inactive-text="关闭"
                   @change="statusChange(row)">
        </el-switch>
      </template>
    </avue-crud>
    <!--    <el-dialog :visible.sync="show" width="30%" :modal-append-to-body="false" append-to-body center>-->
    <!--      <avue-ueditor v-model="form.content" :upload="upload" disabled></avue-ueditor>-->
    <!--    </el-dialog>-->
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/party/meeting";
  import {mapGetters} from "vuex";
  // import AvueUeditor from "avue-plugin-ueditor";
  // import comment from "@/views/party/comment.vue"

  export default {
    // comments: {
    //   AvueUeditor
    // },
    props: {
      branchId: {
        type: String
      }
    },
    data() {
      return {
        upload: {
          action: '/api/blade-resource/oss/endpoint/put-file',
          props: {
            res: "data",
            url: "link",
          }
        },
        commentVisible: false,
        meetingId: 0,
        show: false,
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height: 'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: false,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "会议名称",
              prop: "name",
              row: true,
              search: true,
              rules: [{
                required: true,
                message: "请输入会议名称",
                trigger: "blur"
              }]
            },
            {
              label: "会议图片",
              prop: "img",
              type: 'upload',
              hide: true,
              row: true,
              propsHttp: {
                res: "data",
                url: 'link'
              },
              listType: 'picture-img',
              action: '/api/blade-resource/oss/endpoint/put-file',
              display: true
            },
            {
              label: "会议内容",
              prop: "content",
              // component: 'ueditor',
              component: 'AvueUeditor',
              options: {
                action: '/api/blade-resource/oss/endpoint/put-file',
                props: {
                  res: "data",
                  url: "link",
                }
              },
              minRows: 6,
              width: 150,
              span: 18,
              row: true,
              slot: true,
              rules: [{
                required: true,
                message: "请输入会议内容",
                trigger: "blur"
              }]
            },
            {
              label: "热门状态",
              prop: "hitStatus",
              type: "radio",
              width: 100,
              row: true,
              search: true,
              dicUrl: "/api/blade-system/dict/dictionary?code=yes_no",
              dataType: "number",
              props: {
                label: "dictValue",
                value: "dictKey",
              },
              rules: [{
                required: true,
                message: "请输入热门状态",
                trigger: "blur"
              }]
            },
            {
              label: "通知状态",
              prop: "notificationStatus",
              type: "radio",
              width: 100,
              row: true,
              search: true,
              dicUrl: "/api/blade-system/dict/dictionary?code=yes_no",
              dataType: "number",
              props: {
                label: "dictValue",
                value: "dictKey",
              },
              rules: [{
                required: true,
                message: "请输入通知状态",
                trigger: "blur"
              }]
            },
            {
              label: "会议分类",
              prop: "classId",
              type: "select",
              row: true,
              search: true,
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=party_meeting_class",
              dataType: "number",
              props: {
                label: "dictValue",
                value: "dictKey",
              },
              rules: [{
                required: true,
                message: "请输入会议分类",
                trigger: "blur"
              }]
            },
            {
              label: "会议状态",
              prop: "meetingStatus",
              type: "switch",
              width: 200,
              row: true,
              search: true,
              slot: true,
              dicUrl: "/api/blade-system/dict/dictionary?code=on_off",
              dataType: "number",
              value: 1,
              props: {
                label: "dictValue",
                value: "dictKey",
              },
              rules: [{
                required: true,
                message: "请输入会议状态",
                trigger: "blur"
              }]
            },
            {
              label: "排序",
              prop: "sort",
              rules: [{
                required: true,
                message: "请输入排序",
                trigger: "blur"
              }]
            }
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.meeting_add, false),
          viewBtn: this.vaildData(this.permission.meeting_view, false),
          delBtn: this.vaildData(this.permission.meeting_delete, false),
          editBtn: this.vaildData(this.permission.meeting_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      showComment(row){
        this.meetingId = row.id;
        this.commentVisible = true;
        this.$nextTick(()=>{
          this.$refs.comment.init()
        })
      },
      init(){
        this.onLoad(this.page)
      },
      statusChange(row) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
        }, error => {
          console.log(error);
        });
      },
      showContent(row) {
        this.form = row;
        this.show = true;
      },
      rowSave(row, done, loading) {
        row.branchId = this.branchId;
        row.content = btoa(unescape(encodeURIComponent(row.content)));
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        row.content = btoa(unescape(encodeURIComponent(row.content)));
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage) {
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize) {
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        this.query.branchId = this.branchId
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
